<?PHP
/*
   Plugin Name: Mobio SMS заключване
   Plugin URI: http://www.mobio.bg
   Description: Този плъгин позволява да създавате платени статиите (постове).
   Author: Mobio.bg
   Version: 1.0
   Author URI: http://www.mobio.bg
   */



function mobio_smslock_the_content($content) {

	global $wp_query;
	$post = $wp_query->post;

	$mobio_smslock_entercode_form = '
	<form name="mobio_smslock_check" method="POST" action="">
	<input type="text" class="code" name="mobio_smslock_smscode" size="10" style="border: 1px solid #C0C0C0;width:150px;margin-bottom:15px">
	<input type="submit" name="check_code" value=" Проверка на кода " style="width:150px"/>
	</form>
	';
	$options = get_option("MobioSMSLock");

	$mobio_smslock_formtext = stripslashes($options["mobio_smslock_formtext"]);
	$mobio_smslock_invalid_code = stripslashes($options["mobio_smslock_invalid_code"]);
	$servID = stripslashes($options["mobio_smslock_servID"]);
	$mobio_smslock_postIDs = $options["mobio_smslock_postIDs"];
	$mobio_smslock_entercode = $mobio_smslock_formtext.$mobio_smslock_entercode_form;

	if(is_single()) { 

		if(is_array($mobio_smslock_postIDs) and in_array($post->ID, $mobio_smslock_postIDs)) {

			if($_POST["mobio_smslock_smscode"]) {
				$mobio_smslock_smscode = $_POST["mobio_smslock_smscode"];
			}elseif($_COOKIE["mobio_smslock_smscode"]) {
				$mobio_smslock_smscode = $_COOKIE["mobio_smslock_smscode"];
			}


			if(!$mobio_smslock_smscode) {

				return $mobio_smslock_entercode;

			}else{
				if(mobio_smslock_checkcode_mservIDs($servID, $mobio_smslock_smscode)) {
					return '<script language="Javascript">mobio_setcookie("mobio_smslock_smscode", "'.$mobio_smslock_smscode.'", 10);</script>'.$content;
				}else{
					return $mobio_smslock_invalid_code.$mobio_smslock_entercode;
				}
			}
		}else{
			return $content;
		}
	}else{

		return $content;
	}

}

function mobio_smslock_add_pages() {

	add_options_page('SMS заключване', 'SMS заключване', 10, '', 'mobio_smslock_settings');
	add_meta_box('mobio_smslock_id', 'Mobio SMS заключване', 'mobio_smslock_post_meta_box', 'post', 'side');

}

function mobio_smslock_post_meta_box() {

	$postID = $_REQUEST["post"];
	$options = get_option("MobioSMSLock");

	$mobio_smslock_postIDs = $options["mobio_smslock_postIDs"];
	$checked = (is_array($mobio_smslock_postIDs) and in_array($postID, $mobio_smslock_postIDs));
	if($checked) $checked = 'checked';
	echo '<input type="checkbox" name="mobio_smslock"'.$checked.'/> платен достъп<br/><br/>';

}

function mobio_smslock_settings() {

	echo '<div class="wrap"><h2>Настройки на Mobio SMS заключване</h2>';

	$options = get_option("MobioSMSLock");

	if (!is_array( $options )) {
		$options = array(
				'mobio_smslock_servID' => 29,
				'mobio_smslock_invalid_code' => '<font color="red">Невалиден или изтекъл SMS код</font><br />',
				'mobio_smslock_formtext' => 'За да получите достъп до статията изпратете SMS на номер ХХХХ със съдържание YYY (цена: 1.20лв.)');

		update_option("MobioSMSLock", $options);
	}      


	if($_POST["posted"] == 1) {

		$options['mobio_smslock_servID'] = $_POST['mobio_smslock_servID'];
		$options['mobio_smslock_invalid_code'] = $_POST['mobio_smslock_invalid_code'];
		$options['mobio_smslock_formtext'] = $_POST['mobio_smslock_formtext'];

		update_option("MobioSMSLock", $options);

		echo '<div id="message" class="updated fade"><p><strong>Настройките са запазени...</strong></p></div>';
	}

	echo '<form name="mobio_smslock_settings" method="post">';
	echo '<input type="hidden" name="posted" value="1"/>';
	echo '<fieldset><legend>Mobio servID:</legend><div><input type="text" class="code" size="15" name="mobio_smslock_servID" value="'.$options['mobio_smslock_servID'].'"/></div></fieldset><br/>';
	echo '<fieldset><legend>Отговор при невалиден код:</legend><div><textarea title="true" rows="2" cols="60" name="mobio_smslock_invalid_code">'.stripslashes($options['mobio_smslock_invalid_code']).'</textarea></div></fieldset><br/>';
	echo '<fieldset><legend>Указания за изпращане на SMS:</legend><div><textarea title="true" rows="2" cols="60" name="mobio_smslock_formtext">'.stripslashes($options['mobio_smslock_formtext']).'</textarea><br/></div></fieldset><br/>';

	
	echo '<input type="submit" name="submit" value=" Запази настройките "/></form>';
	echo '<h2>Инструкции:</h2>';
	echo '<p><i>Mobio servID</i> е уникалният ID номер на Вашата услуга <a href="http://help.mobio.bg/show2" target="_blank">Проверка на код</a>. За тестове може да използвате servID <b>29</b> и SMS код <b>T4JC6G</b>.<br/><br/>
	<i>Отговор при невалиден код</i> е съобщението за грешка, което потребителите ще виждат при въвеждане на невалиден код.<br/><br/>
	<i>Указания за изпращане на SMS</i> е текста, който ще виждат потребителите с указания за номера, към който трябва да се изпрати SMS и с какво съдържание. Важно е в указанията да включите и цената за изпращане на SMS към съответния кратък номер.</p><br/>
	<a href="http://mobio.bg" target="_blank">http://mobio.bg</a>
	';
	echo '</div>';
}

function mobio_smslock_save_post($postID) {

	$options = get_option("MobioSMSLock");
	$mobio_smslock_postIDs = $options["mobio_smslock_postIDs"];

	if($_REQUEST["mobio_smslock"]) {

		if(!$mobio_smslock_postIDs) $mobio_smslock_postIDs = array();

		if(!in_array($postID, $mobio_smslock_postIDs)) {
			array_push($mobio_smslock_postIDs, $postID);
			$options["mobio_smslock_postIDs"] = $mobio_smslock_postIDs;
		}

	}else{
		$new_mobio_smslock_postIDs = array();
		while(is_array($mobio_smslock_postIDs) and $mobio_smslock_postIDs) {
			$mobio_smslock_postID = array_pop($mobio_smslock_postIDs);
			if($mobio_smslock_postID != $postID) {
				array_push($new_mobio_smslock_postIDs, $mobio_smslock_postID);
			}
		}
		$options["mobio_smslock_postIDs"] = $new_mobio_smslock_postIDs;

	}

	update_option("MobioSMSLock", $options);

}

function mobio_smslock_checkcode($servID, $code, $debug=0) {

	$ret = 0;

	$mobio_socket = fsockopen("www.mobio.bg", 80);

	if(!$mobio_socket) {
		if($debug)
			echo "Unable to connect to mobio.bg server\n";
		$ret = 0;
	}else{
		$request .= "GET http://www.mobio.bg/code/checkcode.php?servID=$servID&code=$code HTTP/1.0\r\n\r\n";
		fwrite($mobio_socket, $request);
		$result = fread($mobio_socket, 255);
		if(strstr($result, "PAYBG=OK")) {
			$ret = 1;
		}else{
			$ret = 0;
			if($debug)
				echo strstr($result, "PAYBG");
		}
		fclose($mobio_socket);
	}

	return $ret;


}

function mobio_smslock_checkcode_mservIDs($servIDs_str, $code, $debug=0) {

	if(strstr($servIDs_str, ',')) {
		$servIDs = explode(',', $servIDs_str);

		foreach($servIDs as $servID) {
			if(mobio_smslock_checkcode($servID, $code, $debug)) {
				return 1;
			}
		}
	}else{
		return mobio_smslock_checkcode($servIDs_str, $code);
	}
	
	return 0;
}

function mobio_smslock_wp_head() {

	echo '<script language="Javascript">function mobio_setcookie( name, value, expires, path, domain, secure ) {var today = new Date();today.setTime( today.getTime() );if(expires){expires = expires * 1000 * 60 * 60 * 24;}var expires_date = new Date( today.getTime() + (expires) );document.cookie = name + "=" +escape( value ) +( ( expires ) ? ";expires=" + expires_date.toGMTString() : "" ) + ( ( path ) ? ";path=" + path : "" ) + ( ( domain ) ? ";domain=" + domain : "" ) +( ( secure ) ? ";secure" : "" );}function mobio_getcookie(name){var start = document.cookie.indexOf( name + "=" );var len = start + name.length + 1;if((!start)&&(name!=document.cookie.substring(0,name.length))){return null;}if(start==-1)return null;var end = document.cookie.indexOf( ";", len );if ( end == -1 ) end = document.cookie.length;return unescape( document.cookie.substring( len, end ) );}</script>';

}

add_action('wp_head', 'mobio_smslock_wp_head');
add_filter('the_content', 'mobio_smslock_the_content');
add_action('admin_menu', 'mobio_smslock_add_pages');
add_action('save_post', 'mobio_smslock_save_post');

?>
